/*******************************************************************************
Note
----

Before run this test program, you must add absolute path of "lib" directory into
environment "CLASSPATH" and "LD_LIBRARY_PATH". If you are using Windows, you 
must add absolute path of "lib" directory into environment "CLASSPATH" and 
"PATH".  Before using Visual Basic (or any other COM based languages), you must 
register RSS COM library first (Go to "lib" directory in command window, then 
input command "register32 Rsscom.dll").

Compile:
--------
	javac Test.java

Run:
----
	java Test

*******************************************************************************/
import java.util.*;
import rss.*;


/******************************************************************************/
public class Test{

	public static final int RSS_RT_INVALID_COMMAND	=10000;
	public static final int RSS_RT_WANT_QUIT	=10001;
	public static final int RSS_RT_WANT_HELP	=10002;
	public static final int RSS_RT_CHANGE_PROMPT	=10003;

	static Rsst4j Rsst1= new Rsst4j();
	static Rsst4j Rsst0= new Rsst4j();

	static String Description = "====================================================================\nSimple Command Shell Test Program\n====================================================================\n";
	static String HelpText = "\nexit,quit - exit the command shell\nhelp,? - provide help information\nprompt <prompt string>";


/*
 */
static public int CheckResult(){
	int rt= Rsst1.getRtCode();
 if( rt<0 ){
	System.out.println( "Error, RtCode=" + rt );
	System.exit(-1);
 }
	return rt;
}


/*
 */
static void LocateRSSLib(String RSSIEntry){
	String os, rsslib;

 try {
	os = System.getProperty("os.name", "");
 }
 catch (Exception e) {
	os="";
 }

	if( os.toUpperCase().indexOf("WINDOWS") >=0 )
	rsslib="cmdshell.dll";
	else
	rsslib="./libcmdshell.so";

 if( Rsst1.Locate(rsslib, RSSIEntry) !=0 ){
	System.out.println( "Can not locate dynamic library!" );
	System.exit(-1);
 }

 if( Rsst0.Locate(rsslib, RSSIEntry) !=0 ){
	System.out.println( "Can not locate dynamic library!" );
	System.exit(-1);
 }
}


/*
 */
static public void Print(String s){
	Rsst0.Clear();
	Rsst0.KeyPut( "String", s );
	Rsst0.CallRssi( "Print" );
}


/*
 */
static public void main( String astrArg[] ){
	int rt, i, n;
	String cmd;

	LocateRSSLib("CmdShellRssi");

 	Rsst1.Clear();
	Rsst1.KeyPut( "Title", Description );
	Rsst1.KeyPut( "HelpString", HelpText );
	Rsst1.KeyPut( "HelpCommand", "help,?" );
	Rsst1.KeyPut( "ExitCommand", "exit,quit" );
	Rsst1.CallRssi( "Activate" );
	CheckResult();

 /* Get Comand */
 while(true){
	Rsst1.Clear();
	Rsst1.CallRssi("WaitCommand");
	rt= CheckResult();
  if(rt!=0){
	Print( "Command RtCode = <" + rt + ">" + "\n" );

	if(rt==RSS_RT_WANT_QUIT) System.exit(0);;
	continue;
  }
	
	Rsst1.ArrayFetch( "Command" );
	cmd= new String( Rsst1.ArrayGet(1) );

	n= Rsst1.ArrayItemNum();
	if(n==0) continue;

	Print( "You have input a command with " + (n-1) + " argument(s)\nCommand = " + cmd + "\n" );
	for( i=2; i<=n; i++ )
	Print( "Argument No." + (i-1) + " = " + new String( Rsst1.ArrayGet(i) ) + "\n" );
 }
}

}