/*
 * Simple Command Shell RSSI 
 *
 * Author: Liu Rui
 * 
 * RSS (Regular Statement String) is a development tool for software
 * application venders or developers to build their friendly user interfaces or
 * represent their informations.
 *  
 * You may use this software freely and may ask for help from Liu Rui as you 
 * meet any technical problems about it. But Liu Rui does not guarantee your 
 * applications to be well done.
 */

/******************************************************************************/
/*---------------------------- HEADER FILES ----------------------------------*/
#include "cmdshell.h"

#ifdef WIN32
#define RSS_DLL "cmdshell.dll"
#else
#define RSS_DLL "./libcmdshell.so"
#endif


/******************************************************************************/
/*---------------------------- Global Variables ------------------------------*/
Rsst Rsst1, Rsst0;
char *Description = 
"====================================================================\n"
"Simple Command Shell Test Program\n"
"====================================================================\n";
char *HelpText = "\n"
"exit,quit - exit the command shell\n"
"help,? - provide help information\n"
"prompt <prompt string>";


/******************************************************************************/
/*-------------------------------- FUNCTIONS ---------------------------------*/


/*
 */
void Print(char *s){
	RsstClear( &Rsst0 );
	RsstKeyPut0( &Rsst0, "String", s );
	Rsst1.Rssi( &Rsst0, "Print" );
}


/*
 */
int CheckResult(){
	int rt;
	
	rt= RsstGetRtCode(&Rsst1);
if(rt<0){
	printf( "Error, code=%d\n", rt );
	exit(rt);
}

	return rt;
}


/*
 */
int main(){
	int rt, i, n;
	char cmd[128], s[4096];
	
/* Init */
	RsstInit( &Rsst1, 0 );
	RsstInit( &Rsst0, 0 );
if( Locate( &Rsst1, RSS_DLL, "CmdShellRssi" ) ){
	puts("Can not locate RSS DLL");
	exit(-1);
}

	RsstKeyPut0( &Rsst1, "Title", Description );
	RsstKeyPut0( &Rsst1, "HelpString", HelpText );
	RsstKeyPut0( &Rsst1, "HelpCommand", "help,?" );
	RsstKeyPut0( &Rsst1, "ExitCommand", "exit,quit" );
	Rsst1.Rssi( &Rsst1, "Activate" );
	CheckResult();

/* Get Comand */
while(1){
	RsstClear( &Rsst1 );
	Rsst1.Rssi( &Rsst1, "WaitCommand" );
 if(rt= CheckResult()){
	sprintf( s, "Command RtCode = <%ld>\n", rt );
	Print(s);

	if(rt==RSS_RT_WANT_QUIT) exit(0);
	continue;
 }
	
	RsstArrayFetch( &Rsst1, "Command" );
	StringFitIn( cmd, RsstArrayGet0( &Rsst1, 1 ), sizeof(cmd) );

	n= RsstArrayItemNum(&Rsst1);
	if(!n) continue;

	sprintf( s, "You have input a command with %d argument(s)\nCommand = %s\n", n-1, cmd );
	Print(s);
 for( i=2; i<=n; i++ ){
	sprintf( s, "Argument No.%d = %s\n", (i-1), RsstArrayGet0( &Rsst1, i ) );
	Print(s);
 }
}


/* End */
	RsstClose(&Rsst1);
	RsstClose(&Rsst0);
	return 0;
}
