/*
 * Registry RSSI 
 *
 * Author: Liu Rui
 * 
 * RSS (Regular Statement String) is a development tool for software application
 * venders or developers to build their friendly user interfaces or represent
 * their informations.
 *  
 * You may use this software freely and may ask for help from Liu Rui as you 
 * meet any technical problems about it. But Liu Rui does not guarantee your 
 * applications to be well done.
 */

/******************************************************************************/
/*---------------------------- HEADER FILES ----------------------------------*/
#include "../../include/rss.h"


/******************************************************************************/
/*---------------------------- Global Variables ------------------------------*/
Rsst Rsst1;


#ifdef WIN32
#define RSS_DLL "rss4j.dll"
#define SLEEP_FUNC Sleep
#else
#define RSS_DLL "librss4j.so"
#define SLEEP_FUNC sleep
#endif


/******************************************************************************/
/*-------------------------------- FUNCTIONS ---------------------------------*/

/*
 */
int CheckResult(){
	int rt;
	
	rt= RsstGetRtCode(&Rsst1);
if(rt<0){
	printf( "Error, code=%d\n", rt );
	exit(rt);
}

	return rt;
}


/*
 */
int main(){
	
/* Init */
	RsstInit( &Rsst1, 0 );
if( Locate( &Rsst1, RSS_DLL, "Rss4jRssi" ) ){
	puts("Can not locate RSS DLL");
	exit(-1);
}
	
	RsstKeyPut0( &Rsst1, "Class", "weeb/Weeb" );
	RsstKeyPut0( &Rsst1, "DocRoot", "." );
	Rsst1.Rssi( &Rsst1, "Activate" );
	CheckResult();

	RsstClear(&Rsst1);
	Rsst1.Rssi( &Rsst1, "Start" );
	CheckResult();

	while(1)
	SLEEP_FUNC(0);

	RsstClear(&Rsst1);
	Rsst1.Rssi( &Rsst1, "Stop" );
	CheckResult();

/* End */
	RsstClear(&Rsst1);
	Rsst1.Rssi( &Rsst1, "Deactivate" );
	CheckResult();

	RsstClose(&Rsst1);
	return 0;
}
