package weeb;

import java.net.*;
import java.io.*;
import java.util.*;

import rss.*;


/*******************************************************************************
 *
 */
class HTTPServerThread extends Thread {
 	Socket Client1;
 	String DocRoot, DefaultDoc;
	Rsst4j rsstRq;
/*
 */
public HTTPServerThread(Socket client, String doc_root, String default_doc){
	Client1=client;
	DocRoot=doc_root;
	DefaultDoc=default_doc;

	rsstRq= new Rsst4j();
}


/*
 */
static public String UrlDecode(String code_str) throws StringIndexOutOfBoundsException, NumberFormatException{
	StringBuffer sb= new StringBuffer();
	int i, j, n;
	char c;
	String s1;

	n= code_str.length();
	byte[] ba= new byte[n];
 for( i=0; i<n; i++ ){
	c= code_str.charAt(i);
  if(c!='%'){
	sb.append(c);
	continue;
  }

	j=0;
  while( i<n && code_str.charAt(i) == '%' ){
	s1= code_str.substring(i+1, i+3);
	ba[j]= (byte)( Integer.parseInt(s1, 16) );

	j++;
	i+=3;
  }
	i--;

	sb.append( new String(ba, 0, j) );
 }

	return sb.toString();	
}


/* Get all requests
 */
public HTTPRequest getRequest(HTTPInputStream in) throws IOException {
	HTTPRequest request = new HTTPRequest();
	String line=null, s, filename, key, value, pair;
	int i, n, m, len;

	rsstRq.Clear();

 //first line:
	//HTTP mothod
	while( line==null || line.length()==0 )
	line= in.readLine();

	request.addLine(line); //put request into container
	n= line.indexOf(' ');
	s= line.substring(0, n);
	//
	rsstRq.KeyPut( "Method", s ); 

	//filename:
	filename= line.substring(n+1);
	n= filename.indexOf(" ");
	if(n>=0)
	filename= filename.substring(0, n);
	if(filename.charAt(0) == '/') //Remove first '/'
	filename= filename.substring(1);
	//
	filename= UrlDecode(filename);
	//
	if( filename.equals("") //such as 'http://localhost:80'
	|| filename.charAt(filename.length() -1) =='/' ) //such as 'http://localhost:80/'
	filename+=DefaultDoc;
	//
	rsstRq.KeyPut( "ProcessFile0", filename );
	filename= DocRoot+filename;
	rsstRq.KeyPut( "ProcessFile", filename );

	len=0;
 do{
	line= in.readLine();

  if(line.length()>0){
	m= line.indexOf(": ");
   if(m>=0){
	key= line.substring(0,m);
	if( key.equalsIgnoreCase("Content-Length") )
	len= Integer.parseInt(line.substring(m+2));
	else
	rsstRq.KeyPut( key, line.substring(m+2) );
   }
  }
  else{
	if(len==0) break;
	byte[] data= new byte[len];
	n= in.read(data);
   if(len!=n){
	System.out.println("Content-Length mismatch!");
	break;
   }

	line= new String(data);
	StringTokenizer st= new StringTokenizer(line, "&");
   while( st.hasMoreTokens() ){
	pair= st.nextToken();
	m= pair.indexOf("=");
	if(m<0) continue;

	key= pair.substring(0,m);
	value= UrlDecode( pair.substring(m+1) );
	rsstRq.KeyPut( key, value );
   }
	break;
  }

	request.addLine(line); //put request into container
 }while(true);

	return request;
}


/*
 */
public void run(){
	int i;

 try{ 
  if(HTTPServer.Debug >0){ //Display info about the connection
	String destName= Client1.getInetAddress().getHostName(); //Server hostname
	String destAddr= Client1.getInetAddress().getHostAddress(); //Server IP address
	int destPort= Client1.getPort(); //Server port
	System.out.println( "Accepted connection to " + destName + " (" + destAddr + ")" + " on port " + destPort + "." );
  }
	
	HTTPInputStream in= new HTTPInputStream(Client1.getInputStream());
	BufferedOutputStream out= new BufferedOutputStream(Client1.getOutputStream());

	HTTPRequest req= getRequest(in);
	if(HTTPServer.Debug >1) //Show head message
	req.log();

	System.out.println( new String(rsstRq.getRss()) );

	processRequest(out);
 
	in.close();
	out.close();
	Client1.close(); //non persistance
	if(HTTPServer.Debug >0)
	System.out.println("Request completed. Closing connection.");
 }
 catch(Exception e){
	e.printStackTrace();
 }

}

 	
/* Process Request
 */
void processRequest(BufferedOutputStream out){
	String filename, ext, stype;
	int len, n;
	byte buffer[], btype[];

 try{
	filename= new String( rsstRq.KeyGet("ProcessFile") );
  if( filename.length() >0){ //ProcessFile
	File file= new File(filename);
   if(file.exists()){
	DataInputStream din= new DataInputStream(new FileInputStream(file));
	len= (int) file.length();
	buffer= new byte[len];
	din.readFully(buffer);
	din.close();

	n= filename.lastIndexOf('.');
    if(n>0){
	ext= filename.substring(n+1);

	if( ext.equalsIgnoreCase("HTML") || ext.equalsIgnoreCase("HTM") )
	stype="text/HTML";
	else if( ext.equalsIgnoreCase("xml") )
	stype="text/xml";
	else if( ext.equalsIgnoreCase("jpg") || ext.equalsIgnoreCase("jpeg") )
	stype="image/jpeg";
	else if( ext.equalsIgnoreCase("gif") )
	stype="image/gif";
	else if( ext.equalsIgnoreCase("au") )
	stype="audio/basic";
	else if( ext.equalsIgnoreCase("mpg") || ext.equalsIgnoreCase("mpeg") )
	stype="video/mpeg";
	else if( ext.equalsIgnoreCase("txt") )
	stype="text/plain";
	else
	stype="application/octet-stream";
    }
    else{
	stype="text/plain";
    }

	out.write( "HTTP/1.0 200 OK\r\n".getBytes() );
	out.write( ("Content-Length: " + len + "\r\n").getBytes() );
	out.write( "Content-Type: ".getBytes() );
	out.write( stype.getBytes() );
	out.write( "\r\n\r\n".getBytes() );
	out.write(buffer);
	out.flush();
	if(HTTPServer.Debug >0)
	System.out.println( "File sent: " + file.getCanonicalPath() + "\nNumber of bytes: " +len );
   }
   else{
	buffer= "<html><head></head><body>HTTP/1.0 404 Not found</body></html>".getBytes();
	out.write( "HTTP/1.0 404 Not found\r\n".getBytes() );
	out.write( ("Content-Length: " + buffer.length + "\r\n").getBytes() );
	out.write("Content-Type: text/HTML\r\n\r\n".getBytes());
	out.write(buffer);
	out.flush();
	if(HTTPServer.Debug >0)
	System.out.println( "File not found" );
   }
  }
  else{ //ProcessData
	buffer= rsstRq.KeyGet("ProcessData");
	len= buffer.length;
	btype= rsstRq.KeyGet("ContentType");

	out.write( "HTTP/1.0 200 OK\r\n".getBytes() );
	out.write( ("Content-Length: " + len + "\r\n").getBytes() );
   if(btype.length==0){
	out.write( "Content-Type: text/HTML\r\n\r\n".getBytes() );
   }
   else{
	out.write( "Content-Type: ".getBytes() );
	out.write( btype );
	out.write( "\r\n\r\n".getBytes() );
   }
	out.write(buffer);
	out.flush();
	if(HTTPServer.Debug >0)
	System.out.println( "Data sent. " + "\nNumber of bytes: " +len );
  }
 }
 catch(Exception e){
  try{
	out.write(("HTTP/1.0 400 " + "No can do" + "\r\n").getBytes());
	out.write("Content-Type: text/HTML\r\n\r\n".getBytes());

	System.out.println( "found error when processRequest" );
  }
  catch(IOException ioe){
  }
 }
}

}
