package weeb;

import java.net.*;
import java.io.*;


// Proxy server
public class HttpProxy extends Thread {
	//Retry times of connection
	static public int CONNECT_RETRIES=5;
	//Interval for remote connection
	static public int CONNECT_PAUSE=5;
	//Wait user using browser
	static public int TIMEOUT=500;
	//Socket input buffer
	static public int BUFSIZ=1024;
	//log id
	static public boolean logging = true;
	//log output stream
	static public OutputStream log=null;
	public String head="";
	protected Socket Socket;


/* initialize and start proxy
 */
public HttpProxy(Socket s){ 
	Socket=s; 
}


/* write log
 */
public void writeLog(byte[] bytes,int offset, int len) throws IOException {
 for (int i=offset;i<len;i++){	
	log.write((int)bytes[i]);	
 }
}


/*
 */
public void run(){
	String line;
	String host;
	int port=80;
	Socket outbound=null;

 try{
	// Unit: millisecond
	Socket.setSoTimeout(TIMEOUT);
	//get Socket input stream
	InputStream is=Socket.getInputStream();
	host=getHost(is);
	//OutputStream os=Socket.getOutputStream();
  try{
   while (true){
	int n=-1;
	n=host.indexOf(":");
    if (n!=-1){ 
	port=Integer.parseInt(host.substring(n+1));
	host=host.substring(0,n);
    }
	int retry=CONNECT_RETRIES;   
	System.out.println("host is "+host);
    //retry to connect
    while (retry--!=0){
     try{
	//connect with remote host
	outbound=new Socket(host,port);
	break;
     }
     catch (Exception e){
	e.printStackTrace(); 
     }
	//retry after an interval
	Thread.sleep(CONNECT_PAUSE);
    }
	if (outbound==null) break;
	outbound.setSoTimeout(TIMEOUT);
	OutputStream  os1=outbound.getOutputStream();
			 
	byte[] bytes=head.getBytes();
	os1.write(bytes,0,bytes.length);
			    
	pipe(Socket.getInputStream(),outbound.getInputStream(),Socket.getOutputStream(),os1);
	break;
   }
  }
  catch (IOException e) {
  }
 } 
 catch (Exception e){
 }
 finally{
  try {
  	Socket.close();
  } 
  catch (Exception e1) {
  	e1.printStackTrace();
  }
  try {
  	outbound.close();
  } 
  catch (Exception e2) {
  	e2.printStackTrace();
  }
 }
}


/*
 */
public String getHost(InputStream is) throws IOException {
    	String host=null;
    	DataInputStream dis=new DataInputStream(is);
    	//in jdk1.3 API, readLine is replaced with BufferedReader
    	host= dis.readLine();
    	head=host;
	int n=host.indexOf("//");
	if (n!=-1) host=host.substring(n+2);
	n=host.indexOf('/');
	if (n!=-1) host=host.substring(0,n);
	return host;
}


/*
 */
void pipe(InputStream is0, InputStream is1,OutputStream os0,  OutputStream os1) throws IOException {
 try{
	int i;
	byte bytes[]=new byte[BUFSIZ];
  while (true){
   try{
	//write client input stream to server output stream,
	//block when reading if no data in input stream
    if ((i=is0.read(bytes))>0){
	os1.write(bytes,0,i);
	if (logging) writeLog(bytes,0,i);
    }
    else if (i<0){
	break;
    }
   } 
   catch (InterruptedIOException e) {
   }
		
   try {
	//write server input stream to client output stream,
	//block when reading if no data in input stream
    if ((i=is1.read(bytes))>0){
	os0.write(bytes,0,i);
	if (logging) writeLog(bytes,0,i);
    }
    else if (i<0){
	break;
    }
   } 
   catch (InterruptedIOException e){ 
	e.printStackTrace();
   }
  }
 } 
 catch (Exception e){
	System.out.println("Pipe Exception: " + e);
	e.printStackTrace();
 }
}


/*
 */
static public void main(String args[]) {
	System.out.println("Starting proxy on port 808");
	int port = 808;
	HttpProxy.log=System.out;
	HttpProxy.logging=true;
	ServerSocket ssock;
	Socket sock;
  
 try {
	ssock=new ServerSocket(port);
  while (true){
	sock =ssock.accept();
	(new HttpProxy(sock)).start();
  }
 } 
 catch (Exception e){
	e.printStackTrace();
 }
}


}
