/*
 * Registry RSSI 
 *
 * Author: Liu Rui
 * 
 * RSS (Regular Statement String) is a development tool for software
 * application venders or developers to build their friendly user interfaces or
 * represent their informations.
 *  
 * You may use this software freely and may ask for help from Liu Rui as you 
 * meet any technical problems about it. But Liu Rui does not guarantee your 
 * applications to be well done.
 */

/******************************************************************************/
/*---------------------------- HEADER FILES ----------------------------------*/
#include "registry.h"


/******************************************************************************/
/*---------------------------- Global Variables ------------------------------*/
Rsst Rsst1;


#ifdef WIN32
#define RSS_DLL "registry.dll"
char IniFile[]= ".\\myreg.ini";
#else
#define RSS_DLL "./libregistry.so"
char IniFile[]= "./myreg.ini";
#endif


/******************************************************************************/
/*-------------------------------- FUNCTIONS ---------------------------------*/

/*
 */
int CheckResult(){
	int rt;
	
	rt= RsstGetRtCode(&Rsst1);
if(rt<0){
	printf( "Error, code=%d\n", rt );
	exit(rt);
}

	return rt;
}


/*
 */
int main(){
	
/* Init */
	RsstInit( &Rsst1, 0 );
if( Locate( &Rsst1, RSS_DLL, "RegistryRssi" ) ){
	puts("Can not locate RSS DLL");
	exit(-1);
}
	
	RsstKeyPut0( &Rsst1, "RegName", IniFile );
	Rsst1.Rssi( &Rsst1, "Activate" );
	CheckResult();

	puts("---Write Registry File---");

	RsstClear( &Rsst1 );
	RsstKeyPut0( &Rsst1, "KeyName", "Name" );
	RsstKeyPut0( &Rsst1, "Value", "Liu Rui" );
	RsstKeyPut0( &Rsst1, "SectionName", "Profile" );
	Rsst1.Rssi( &Rsst1, "WriteKey" );
	CheckResult();

	RsstClear( &Rsst1 );
	RsstKeyPut0( &Rsst1, "KeyName", "Title" );
	RsstKeyPut0( &Rsst1, "Value", "Mr." );
	RsstKeyPut0( &Rsst1, "SectionName", "Profile" );
	Rsst1.Rssi( &Rsst1, "WriteKey" );
	CheckResult();

	RsstClear( &Rsst1 );
	RsstKeyPut0( &Rsst1, "KeyName", "Phone" );
	RsstKeyPut0( &Rsst1, "Value", "123-456-7890" );
	RsstKeyPut0( &Rsst1, "SectionName", "Profile" );
	Rsst1.Rssi( &Rsst1, "WriteKey" );
	CheckResult();
	
	RsstClear( &Rsst1 );
	RsstKeyPut0( &Rsst1, "KeyName", "Software" );
	RsstKeyPut0( &Rsst1, "Value", "Regular Statement String (RSS)" );
	RsstKeyPut0( &Rsst1, "SectionName", "Products" );
	Rsst1.Rssi( &Rsst1, "WriteKey" );
	CheckResult();

	puts("\n---Read Registry File---");
	
	RsstClear( &Rsst1 );
	RsstKeyPut0( &Rsst1, "KeyName", "Phone" );
	RsstKeyPut0( &Rsst1, "SectionName", "Profile" );
	Rsst1.Rssi( &Rsst1, "ReadKey" );
	CheckResult();

	printf( "The phone number got from registry file is: %s\n", RsstKeyGet0( &Rsst1, "Value" ) );

/* End */
	RsstClose(&Rsst1);
	return 0;
}
