/*
 * Registry RSSI 
 *
 * Author: Liu Rui
 * 
 * You may use this software freely and may ask for help from Liu Rui as you meet
 * any technical problems about it. But Liu Rui do not guarantee your applications
 * to be well done.
 *
 * Because the RSSI server is simplified without RSSI Handle support, the client can not call the server from different thead.
 */

import java.io.*;
import java.util.*;
import rss.*;


/***********************************************************
 ***********************************************************/
public class Test{
	static Rsst4j Rsst1= new Rsst4j();

/*
 */
static public void CheckResult(){
	int rt= Rsst1.getRtCode();
 if( rt!=0 ){
	System.out.println( "Init RtCode=" + rt );
	System.exit(-1);
 }
}


/*
 */
static public void main( String astrArg[] ) throws java.io.IOException{
	int rt;
	char c;

 /*Init*/
	rt= Rsst1.Locate("Rss4Vb", "Rss4VBRssi");
 if(rt!=0){
	System.out.println( "Can not locate dynamic library!" );
	System.exit(-1);
 }

	Rsst1.Clear();
	Rsst1.KeyPut( "PrgID", "Waiter.Serve" );
	Rsst1.KeyPut( "EntryName", "VBRssi" );
	Rsst1.CallRssi( "Activate" );
	CheckResult();

	BufferedReader in= new BufferedReader( new InputStreamReader( System.in ) );
 /*CallVB*/
	System.out.println("Options:");
	System.out.println("0 - Quit");
	System.out.println("1 - Send Email");
	System.out.println("2 - Word");
	System.out.println("3 - Excel");

 do{
	String input = in.readLine();
	
	if( input.length()>0 )
	c= input.charAt(0);
	else
	c = ' ';

  switch( c ){
  case '0':
	System.out.println("Quit...");
	break;  
  case '1':
	System.out.println("Send Email...");
	Rsst1.Clear();
	Rsst1.KeyPut( "ToAddr", "liurui@lrsolution.com" );
	Rsst1.CallRssi( "SendEMail" );
	break;  
  case '2':
	System.out.println("Use Word...");
	Rsst1.Clear();
	Rsst1.KeyPut( "Text", "RSS is very easy to use." );
	Rsst1.CallRssi( "UseWord" );
	break;  
  case '3':
	System.out.println("Use Excel...");
	Rsst1.Clear();
	Rsst1.KeyPut( "Text", "Database" );
	Rsst1.CallRssi( "UseExcel" );
	break;  
  default:
	System.out.println("Unknow input");
	break;  
  } 
 }while(c!='0');

 /*End*/
	Rsst1.Clear();
	Rsst1.CallRssi( "Deactivate" );
	CheckResult();
}

}
